/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File alex.h, lexical analyzer
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*/
 
#ifndef _ANALEX_
#define _ANALEX_

#include <values.h>
#include "constant.h"
#include "conjunto.h"
#include "tipos.h"

/***************************************************************************/
/************** Tipos para el analizador lexico y sintactico ***************/
/***************************************************************************/

enum terminales {programsim=1,ident,punto,defconstsim,igual,numero,puncom,
		 recordsim,endsim,intesim,dospunto,puntopunto,defclasesim,
		 definstancesim,defpatternsim,coma,rulesim,abrepar,defrulesim,
		 implisim,cierrapar,distinto,menorig,menor,mayorig,mayor,mas,menos,
		 opmult,opdiv,existe,paratodo,opnosim,oposim,dolar,nulo,asigna,
		 isasim, abrecor,cierracor,inputsim,realsim,prinsim,subclasesim,
		 ofsim,slotsim,clasesim,defaultsim,frecuencysim,proceduresim,

		 deffunctionsim,setstrategysim,depthsim,widthsim,charsim,returnsim,
		 intlistsim,realistsim,addheadsim,addtailsim,headsim,tailsim,
		 booleansim,opysim,haltsim,falsesim,truesim,cadenasim,externsim,
		 defvariables,popheadsim,poptailsim,sizesim,typesim,accesorsim,readsim,
		 writesim,temposlotsim,nbpredictsim,nbvaluessim,

		 includesim, extfilesim, importsim, kdmsim, directiva, arraysim, factssim
};

/**** variables ****/

extern char ch;                /* caracter que se esta procesando */
extern char enteroseguidodospuntos;
extern char linea[long_linea];
extern int obt_orig;           /* booleano que controla si se devuelven */
                               /* pasados a mayusculas o no */
extern int numlinea,contcarac,longlineactual,aux,opes;
extern char leidosigcar;
extern char regla_error;
extern char errorahora;
extern char declarando; /* para saber si estoy declarando */
extern char error_rango; /* para cuando el entero es mayor del rango permitido */
extern char tipdelreg;
extern char cterepetida; /* me indicara si hay una constante repetida */
/****** Valores devueltos por el analizador lexico ******/

extern REGTDS   * elemtds;    /* elemento de la tabla tds al que accedo */
extern REGTIPO  * elemtip;    /* elemento de la tabla tipo al que accedo */

extern char id[long_ident+1];  /* pongo uno mas para el caracter nulo */
extern char idaux[long_ident+1];
extern char cadena_comillas[max_cadena_comillas+1]; /* Valor de la cadena leida: token 'cadenasim' */
extern char simbolo;    /* ultimo simbolo leido */
extern float num;       /* valor de una constante numerica */
extern char esreal;     /* me dice si he leido un numero real */

extern int is_kdm_level; //Indica si el archivo en proceso es del kdm. 


/*** array de palabras reservadas */

extern char pr[][long_ident];  /* pongo tamao 14, para introducir el nulo */

extern char simpalres[num_pal_reser+1];


/* funciones de Alex.c */
void empareja();
void sincroniza();
void obtsym();
char obtch();
int Inicializa_Analizador_Lexico();
void Cierra_Analizador_Lexico();
#endif








