/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File errores.c, error messages
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*/




#include "errores.h"
#include "alex.h"

///////////////////////////////////////////////////////////////////////////

//Estas dos variables permiten controlar la lnea en la que ocurre un error
//con respecto al fichero.

int pila_lineas[max_pila_f]; 
//En los incluide, acumula la lnea que se
//estava procesando con respecto a ese fichero


int numlinea_acumulado = 0;
//Permite recalcular la lnea actual del fichero actual.
//Representa el desfase entre el nmero de lnea del fichero actual
//y el nmero total de lneas procesadas (de cualquier fichero).
//En la insercin toma el valor de la var global numlinea
//En la extraccin numlinea - lineas ya procesadas para ese fichero.
//De esta forma se puede calcular el desplazamiento dentro de un fichero.
//Nota: Seguramente esto no hara falta, pues parece que numlinea
//no se usa para otra cosa, ms que para contar lneas.



///////////////////////////////////////////////////////////////////////////


 
char algunerror; /* para saber si ha habido algun error */
char mensajeerror[][80]=
{"0.",
"1. ERROR: Ident too long. Long must be  <=",
"2. ERROR: Constant out of range",
"3. ERROR: Incompatible types",
"4. ERROR: Invalid character",
"5. ERROR: Out of memory !!",
"6. ERROR: Only 1 pattern_var is allowed in an expression",
"7. ERROR: Error in defrule",
"8. ERROR: Error in the action part.",
"9. ERROR: , expected",
"10. ERROR:  ; expected",
"11. ERROR: An indent expected",
"12. ERROR:  RETURN expected",
"13. ERROR: A number expected",
"14. ERROR: := expected",
"15. ERROR: : expected",
"16. ERROR: HEAD expected",
"17. ERROR: => expected",
"18. ERROR: .. expected",
"19. ERROR: Field delimiter expected",
"20. ERROR: TAIL expected",
"21. ERROR: ) expected",
"22. ERROR: ( expected",
"23. ERROR: = expected",
"24. ERROR: DEFRULE expected",
"25. ERROR: ADD_HEAD expected",
"26. ERROR: Variable or class name expected",
"27. ERROR: Class name expected",
"28. ERROR: DEFPATTERN expected",
"29. ERROR: Error in sign",
"30. ERROR: DEFCONST expected",
"31. ERROR: DEFFUNCTION expected",
"32. ERROR: DEFCLASS expected",
"33. ERROR: A standard type expected",
"34. ERROR: A data type expected",
"35. ERROR: DEFINSTANCE expected",
"36. ERROR: TAIL expected",
"37. ERROR: ISA expected",
"38. ERROR: OF expected",
"39. ERROR: Error in expression.",
"40. ERROR: Error in expression (Termino)",
"41. ERROR: General sintax error",
"42. ERROR: SLOT or TEMPOSLOT expected",
"43. ERROR: FRECUENCY expected",
"44. ERROR: INPUT expected",
"45. ERROR: Error in expression (Factor)",
"46. ERROR: A number or a ( expected",
"47. ERROR: Error in variable",
"48. ERROR: A slot is required",
"49. ERROR: pattern_var expected",
"50. WARNING: class initialized before",
"51. ERROR: Error in the class initilization",
"52. ERROR: Error in the condition",
"53. ERROR: Max. long of line exceded",
"54. ERROR: Max. number of constants exceded",
"55. ERROR: A variable expected (not a pattern_var)",
"56. ERROR: Number, variable, +, or  - expected",
"57. ERROR: Number, (, or variable expected",
"58. ERROR:  * or / expected",
"59. ERROR: Number, (, or variable expected",
"60. WARNING: Variable inicilizated before",
"61. ERROR: Inizialization of inputvar is not allowed here",
"62. ERROR: pattern_var can not be inizializated",
"63. ERROR: Only inputvar can be inizializated here",
"64. ERROR: End of program not found",
"65. ERROR: TYPE expected",
"66. ERROR: Ident duplicated (constant)",
"67. ERROR: Ident duplicated (defined type)",
"68. ERROR: Ident duplicated (class)",
"69. ERROR: Duplicated rule",
"70. ERROR: Duplicated ident",
"71. ERROR: Error of range",
"72. ERROR: List of numbers not completed. Review the INIT part",
"73. ERROR: Ident not declared",
"74. ERROR: Too many fields in inicialization of class",
"75. ERROR: More fields are required in inizialization of class",
"76. ERROR: Multiple declaration.",
"77. ERROR: DEFAULT expected",
"78. ERROR: pattern_var not instanced in right part of assignament",
"79. ERROR: The pattern_var can not be instanced",
"80. ERROR: Rule priority out of range",
"81. ERROR: PROCEDURE expected",
"82. ERROR: SETSTRATEGY expected",
"83. ERROR: OF expected",
"84. ERROR: This version not allow use two 'forall' in the same test",
"85. ERROR: Action only allowed in a function",
"86. ERROR: Slot name invalid",
"87. ERROR: Other fields must be inizializated",
"88. ERROR: DEPTH or WIDTH expected",
"89. ERROR: Ident not declared as parameter",
"90. ERROR: Invalid number of parameters",
"91. ERROR: Ident not declared",
"92. ERROR: Invalid name of function",
"93. ERROR: List type expected",
"94. ERROR: Integer constant expected",
"95. ERROR: Constant expected",
"96. ERROR: Field name not included in the class definition",
"97. ERROR: Integer or real number expected",
"98. ERROR: List are not allowed in conditional expressions",
"99. ERROR: $ char is reserved. Please, do not use it",
"100. ERROR: Instance or variable expected",
"101. ERROR: ] expected",
"102. ERROR: A valid directive expected",
"103. ERROR: Recursive structure not allowed",
"104. ERROR: Boolean expression expected",
"105. ERROR: Pattern variables are not allowed in functions",
"106. ERROR: RETURN only can be used in functions", /*=85 */
"107. ERROR: Invalid type of parameter",
"108. ERROR: EXTERN expected",
"109. ERROR: Invalid reference parameter",
"110. ERROR: String expected",
"111. ERROR: Function not return any data",
"112. ERROR: Integer expression expected",
"113. ERROR: A valid Arlips declaration expected (def...)",
"114. ERROR: Max number of extern files is 25",
"115. ERROR: Only read and write accesor are allowed",
"116. ERROR: \"filename\" expected",
"117. ERROR: The parser of the kdm has failed",
"118. ERROR: # or ( expected",
"119. ERROR: #include expected",
"120. ERROR: Max. included files exceded", /*=114*/
"121. ERROR: File could not be opened",
"122. ERROR: The string is too long",
"123. ERROR: Declared size is smaller than initialization size",
"124. ERROR: Existencialy quantified patternvar cannot be negated",
"125. ERROR: The size of the array is expected",
"126. ERROR: Unsuported type of the array",
"127. ERROR: [ expected",
"128. ERROR: Do not mix quantifiers for a patternvar in a rule."
};




/*******  tratamiento de errores  *******/

void menerror(//numerror, error_)
	      int numerror,
	      char *error_) {
  char c;
  int i;
  extern cima_pila;
  
  *error_=TRUE;
  algunerror=TRUE;
  /* Cuando se produce un error se imprime la linea actual */
  fprintf(stderr,"%s:%d: ", pila_nombres_ficheros[cima_pila], numlinea - numlinea_acumulado);
  //  fprintf(stderr,"\n");
  //  for(i=1; i<=longlineactual; i++)
  //fprintf(stderr,"%c",linea[i]);
  //  fprintf(stderr,"\n");
  switch(numerror) {
  case 0:
    fprintf(stderr," Error\n"); break;
  case 1:
    fprintf(stderr,"%s %d\n",mensajeerror[1],long_ident); break;
  default: 
    fprintf(stderr," %s\n",mensajeerror[numerror]);
  }  

  for(i=1; i<=longlineactual; i++)
    fprintf(stderr,"%c",linea[i]);

  fprintf(stderr,"\n");
  fprintf(stderr,"\n");
  /* des-comentando esta linea se obliga al usuario a tragarse todos los */
  /* errores */
  /*  getchar(); */
}

void menerror_1(numerror)
int numerror;
{
char error_=FALSE;

 menerror(numerror,&error_);
}


void actualiza_contador_linea_insercion (int total_lineas_procesadas, int cima_pila) {
  //Se podra hacer por variales globales, pero por elegancia se va a hacer
  //por parmetros.
  //total_lineas_procesadas se correspondera con numlinea
  //cima_pila con cima_pila

  pila_lineas[cima_pila] = total_lineas_procesadas - numlinea_acumulado;
  numlinea_acumulado = total_lineas_procesadas;
}

void actualiza_contador_linea_extraccion (int total_lineas_procesadas, int cima_pila) {
  numlinea_acumulado = total_lineas_procesadas - pila_lineas[cima_pila];
}
